// *********************************************************************
//  created:    2007/11/13 - 16:51
//  filename:   DbtPlyAlascaManager.h
//
//  author:     Gerald Dherbomez
//              Copyright Heudiasyc UMR UTC/CNRS 6599
//
//  version:    $Id: $
//
//  purpose:
// *********************************************************************

#ifndef DBTPLYALASCAMANAGER_H
#define DBTPLYALASCAMANAGER_H

#include <fstream>

#include "DbitePlayer/DbtPlyFileManager.h"
//#include "structure/structure_telemetre.h"
#include "../Alasca/AlascaData.h"
#include "StdDbtPlayerComponentsConfig.h"
#include <Pacpus/structures/genericLidarStructures.h>

namespace pacpus {

class ShMem;

class STDDBTPLAYERCOMPONENTS_API DbtPlyAlascaManager
        : public DbtPlyFileManager
{
    Q_OBJECT
public:
    DbtPlyAlascaManager(QString name);
    ~DbtPlyAlascaManager();

protected:
    void processData(road_time_t t, road_timerange_t tr, void * buffer);
    void displayUI();

    ComponentBase::COMPONENT_CONFIGURATION configureComponent(XmlComponentConfig config);
    void startActivity();
    void stopActivity();

    virtual void addInputs();
    virtual void addOutputs();

private:
    //ShMem * mShMem;// deprecated
    ScanAlascaData mAlascaData;
    LidarScan lidarScan;

    std::ifstream mDataFile;
    QString mDataFilename;
};

} // namespace pacpus

#endif // DBTPLYALASCAMANAGER_H
